<cffunction name="renderMethods" output="false" returntype="string">
	<cfargument name="label" />
	<cfargument name="list" />
	<cfset var result = "" />
	<cfset var methods = structNew() />
	<cfset var s = "" />
	<cfset var params = "" />
	<cfset var i = "" />
	<cfset var j = "" />
	<cfloop from="1" to="#arrayLen(list)#" index="i">
		<cfset s = structNew() />
		<cftry>
			<cfset s.returnType = list[i].getReturnType() />
			<cfcatch type="any">
				<cfset s.returnType = "" />
			</cfcatch>
		</cftry>
		<cfset s.name = list[i].getName() />
		<cfset s.params = REReplace(list[i].toString(), "^.*\((.*)\).*$", "\1") /> />
		<cfset s.toString = list[i].toString() />
		<cfset methods[REReplace(s.name & "(" & s.params & ")", ",", "_", "all")] = s />
	</cfloop>
	<cfoutput>
	<cfsavecontent variable="result">
	<table>
	<tr>
		<th colspan="2">#label#</th>
	</tr>
	<cfloop list="#listSort(structKeyList(methods), 'textnocase')#" index="i">
		<tr>
			<td>#methods[i].returnType#</td>
			<td>
				<strong style="color:blue;" title="#methods[i].toString#">#methods[i].name#</strong>(
				<cfloop list="#methods[i].params#" index="j">
					<cfif j CONTAINS ".">
						<a href="?clazz=#j#">#j#</a>
					<cfelse>
						#j#
					</cfif>,
				</cfloop>
				)
			</td>
		</tr>
	</cfloop>
	</table>
	</cfsavecontent>
	</cfoutput>
	<cfreturn REReplace(result, ",[[:space:]]*\)", ")", "all") />
</cffunction>

<cfoutput>
<cfparam name="attributes.clazz" default="coldfusion.tagext.sql.QueryTag" />
<form method="post" action="?">
	<input name="clazz" value="#attributes.clazz#" />
	<input type="submit" />
</form>
<h1>#attributes.clazz#</h1>
<cfset o = createObject("java", attributes.clazz) />
<cfset c = o.getClass() />
#renderMethods("Constructors", c.getDeclaredConstructors())#
#renderMethods("Methods", c.getMethods())#
</cfoutput>