Query = Class.create();
Query.defaultDatasource = "";
Query.prototype = Object.extend(new Object, {
	
	initialize: function(sql, datasource) {
		this.sql = sql;
		this.datasource = typeof datasource != "undefined" ? datasource : Query.defaultDatasource;
	},
	
	execute: function(params) {
		if (typeof params == "undefined") {
			params = [];
		}
		var tag = {
			datasource: this.datasource,
			sql: this.sql,
			params: params
		};
		return Util.runTag("cfquery", tag);
	}	
});
