QueryParam = Class.create()
QueryParam.prototype = Object.extend(new Object, {
	
	/*
	 * In addition to the "normal" type values (the part after "cf_sql_"
	 * in the CFSQLTYPE attribute of CFQUERYPARAM, you can also pass the
	 * special value "null", which will send a null to the database. 
	 */
	initialize: function(value, type, isList) {
		this.value = value;
		this.type = typeof type == "undefined" || type == null ? "varchar" : type;
		this.isList = typeof isList == "undefined" || isList == null ? false :isList;
	},
	
	toJava: function() {
		return Util.toJava({
			value: this.value,
			type: this.type,
			isList: this.isList
		});
	}
	
});